#!/usr/bin/perl

# bbs-scene.org random onelinerz
# written by Frank Linhares aka Netsurge
# frank@bbs-scene.org
#
# Revision 1.1
#
# Last update: October 20, 2011
#
# Changelog
#
# +removed curl requirement and started to pull XML directly from API
#
# Simply run the script in your command shell where you want the radom oneliner to appear:
#
# /path/to/rdmliner.pl
#
# Configure your variables below

# Use modules

# Configure your bbs-scene.org username and password
my $username   = "frank\@bbs-scene.org"; 	     # bbs-scene.org username. Remember to escape the @ with a \
my $password   = "option1120";					 # bbs-scene.org password.
my $url 	   = "http://bbs-scene.org/api/onelinerz.php?random";

# DO NOT EDIT BELOW

# Check for LWP::UserAgent and XML::Simple modules
eval { use LWP::UserAgent; };
if ($@) {
    print "You need the LWP::UserAgent module installed.\r\n";
    exit;
}

eval { use XML::Simple; };
if ($@) {
    print "You need the XML::Simple module installed.\r\n";
    exit;
}

# Grab random onelinerz

my $xmlresponse = &bbssceneApiGet( $username, $password, $url );

# create xml object
$xml = new XML::Simple();

# strip illegal characters from xml response
&stripIllegal($xml);

# read XML file
$data = $xml->XMLin("$xmlresponse") or die "Can't process xml response : $!";

$text = substr($data->{node}->{oneliner},0,52);

    $oneliner = "\e[30;1m:\e[37;0m"
      . $text
      . " \e[30;1m[\e[37;1m"
      . $data->{node}->{alias}
      . "\e[35;0m/\e[35;1m" . $data->{node}->{bbsname} . "\e[30;1m] \e[30;0m";

    print $oneliner
      . "\n";

# strip illegal characters sub

sub stripIllegal {
        my ( $input ) = @_;
        # allowed: [#x1-#xD7FF] | [#xE000-#xFFFD] | [#x10000-#x10FFFF]
        $input =~ s/[^\x01-\x{D7FF}\x{E000}-\x{FFFD}\x{10000}-\x{10FFFF}]//go;
        # restricted:[#x1-#x8][#xB-#xC][#xE-#x1F][#x7F-#x84][#x86-#x9F]
        $input =~ s/[\x01-\x08\x0B-\x0C\x0E-\x1F\x7F-\x84\x86-\x9F]//go;
        # Strip any backslashes and illegal characters from the user input
    $input =~ s/\\\\([^\\\\])/$1/g;
}

# bbs-scene.org api pull sub

sub bbssceneApiGet {
    my ( $username, $password, $api ) = @_;
    my $entrybrowser = LWP::UserAgent->new;
    $entrybrowser->agent('bbssceneapi/1.01');
    $entrybrowser->timeout(2);
    $entrybrowser->credentials(
        'bbs-scene.org:80',
        'bbs-scene.org api',
        $username => $password
    );
    my $entry = $entrybrowser->get($api);
    $output = $entry->decoded_content;
    return $output;
}
